/************************************************************/
/*															*/
/************************************************************/
#include	<stddef.h>
#include	<ctype.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

extern int message_flag;

/* -------------------------------------------------------------
 * pXf~^ǂf
 * t@CΉ?
 * -------------------------------------------------------------*/
int is_pathdelimiter(char c)
{
#if defined(UNIX) || defined(LINUX)
	return (c == '/');
#else
	return (c == '\\' || c == '/');
#endif
}



/*--------------------------------------------------------------
	ptrpX/t@Cl[/gqɕ(path,name,extɃRs[)
 Input:

 Output:
	none
--------------------------------------------------------------*/
void splitPath( char *ptr, char *path, char *name, char *ext )
{
	char *temp,*eopath,*eoname;

	if( *ptr == '\0' ) {								/* G[`FbN */
		*path = '\0';
		*name = '\0';
		*ext = '\0';
		return;
	}

	temp = ptr;
	while( *temp != '\0' ) ++temp;						/* xŌ܂Ői */
	eoname = temp;
	while( --temp != ptr ) {
		if( is_pathdelimiter(*temp) ) {
			temp++;
			break;
		}
	}
	eopath = temp;
	while( *temp != '\0' ) {
		if ( *temp == '.' ) {
			eoname = temp;
		}
		++temp;
	}
	strncpy( path, ptr, eopath-ptr );
	*(path+(eopath-ptr)) = '\0';
	strncpy( name, eopath, eoname-eopath );
	*(name+(eoname-eopath)) = '\0';
	strcpy( ext, eoname );
}



/*--------------------------------------------------------------
  	path + name + ext  ptr ɃRs[
 Input:

 Output:
	none
--------------------------------------------------------------*/
void makePath( char *ptr, char *path, char *name, char *ext )
{
	strcpy( ptr, path );
	strcat( ptr, name );
	strcat( ptr, ext );
}



/*--------------------------------------------------------------
	t@CTCY߂
 Input:
	char	fname	:FILE NAME
 Return:
	t@CTCY(0̏ꍇ̓G[)
--------------------------------------------------------------*/
int getFileSize( char *ptr )
{
	FILE	*fp;
	int		size;

	fp = fopen( ptr, "rb" );
	if( fp == NULL ) return 0;

	fseek( fp, 0L, SEEK_END );
	size = ftell( fp );
	fseek( fp, 0L, SEEK_SET );
	fclose( fp );

	return size;
}



/*--------------------------------------------------------------
	t@Cǂݍ
 Input:
	char	fname	:FILE NAME
 Return:
	|C^(NULL̏ꍇ̓G[)
--------------------------------------------------------------*/
char *readFile( char *filename, char *atr )
{
	FILE	*fp;
	int		size;
	char	*ptr;

	/* TCY擾 */
	size = getFileSize( filename );
	if( size == 0 ) {
		if (message_flag == 0) {
			printf( "%s : t@Ct@CTCY0ł\n", filename );
		} else {
			printf( "%s : No file or file is empty\n", filename );
		}
		return NULL;
	}

	/* obt@쐬 */
	ptr = malloc(size + 1); /* Ƀit̂1oCg */
	if( ptr == NULL ) {
		if (message_flag == 0) {
			printf( "%s : mۏo܂ł\n", filename );
		} else {
			printf( "%s : Out of memory\n", filename );
		}
		return NULL;
	}
	/* t@CI[v */
	fp = fopen( filename, atr );
	if ( fp == NULL ) {
		if (message_flag == 0) {
			printf( "%s : t@CJ܂ł\n", filename );
		} else {
			printf( "%s : Can't open\n", filename );
		}
		return NULL;
	}
	size = fread( ptr, 1, size, fp );
	*(ptr+size) = '\0';					/* IEOSt */
	fclose( fp );

	return ptr;
}
